/*
    American option pricer under proportional transaction costs
    Copyright (C) 2011 Alet Roux alet.roux@york.ac.uk

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef PARAMETERCONSTANT_H
#define PARAMETERCONSTANT_H

#include "parameter.h"

///Parameter with fixed value.
class ParameterConstant : public Parameter
{
public:
	ParameterConstant (const coefficient value)	:	_value (value)	{};

	virtual coefficient operator()(const coefficient time) const	{	return value();	};

	virtual ParameterConstant* clone() const	{	return new ParameterConstant(*this);	};


protected:
	///Value of constant parameter
	coefficient value() const	{	return _value;	};

private:
	coefficient _value;
};

#endif // PARAMETERCONSTANT_H
