/*
    American option pricer under proportional transaction costs
    Copyright (C) 2011 Alet Roux alet.roux@york.ac.uk

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef NEG_H
#define NEG_H

//#include "payoff.h"

///Negates #Payoff.
class PayoffNeg : public Payoff
{
public:
	PayoffNeg (const Payoff& payoff) { _payoff = payoff.clone();};

	Portfolio operator() (const Spot& spot) const
	{
		return -(_payoff->operator() (spot));
	}

	PayoffNeg* clone() const
	{
		return new PayoffNeg (*_payoff);
	}

	~PayoffNeg()
	{
		delete _payoff;
	}

private:
	Payoff* _payoff;
};


#endif // NEG_H
